#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
# Copyright (C) 2008 Siegfried-A. Gevatter
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

from distutils.core import setup
import os
import glob

def getKDEDir():
    if os.path.exists("/usr/bin/kde4-config"):
        kdeconfig_path="/usr/bin/kde4-config"
    elif os.path.exists("/usr/lib/kde4/bin/kde4-config"):
        kdeconfig_path="/usr/lib/kde4/bin/kde4-config"
    else:
        print "You are missing the required KDE4 libraries. Please download KDE 4.1-beta2."
        print "For Ubuntu users download it from the PPA at http://launchpad.net/~kubuntu-members-kde4/+archive ."
        print "For more information: see http://leonov.tv/content/used-python-modules-dependencies"
        exit(1)
    prefix = os.popen(kdeconfig_path + " --prefix 2> /dev/null").readline()
    if prefix == '':
        prefix = '/usr'
    else: 
        prefix = prefix[:-1]
    return prefix

if __name__ == "__main__":
    
    # Note: The manpage has to be installed manually.
    
    if os.getcwd().endswith('dist'):
        os.chdir("../")
    
    setup(
        name = "leonov",
        version = "0.0.1",
        author = "The Leonov Team",
        author_email = "project-leonov@lists.launchpad.net",
        url = "http://leonov.tv",
        license = "GPL2+",
        data_files = [
            (getKDEDir() + "/share/kde4/apps/leonov/", ["leonov/kde/leonovui.rc"]),
            ("/usr/share/doc/leonov/", ["AUTHORS"]),
            ("/usr/share/doc/leonov/examples/", glob.glob("data/*.example")),
            ("/usr/share/applications/", glob.glob("data/*.desktop")),
            ("/usr/share/pixmaps/", glob.glob("data/*.png") + glob.glob("data/*.xpm")),
            ("/usr/share/leonov", ["leonov/gtk/leonov-builder.ui"]),
          ],
        scripts = [
            "scripts/leonov"
          ],
        packages = [
            "leonov",
            "leonov.launchpadbugs",
            "leonov.backend",
            "leonov.gtk",
            "leonov.kde",
            "leonov.kde.models",
            "leonov.kde.models.threads",
            "leonov.kde.views",
            "leonov.kde.views.UI",
            "leonov.kde.views.UIHelpers",
          ],
    )
