#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Siegfried-A. Gevatter
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

import threading
import logging
import Queue

from leonov.backend import Global, Holder

class PooledThread(threading.Thread):
    
    def run(self):
        
        while True:
            
            job = pool.get()
            
            if job != None:
                self.execution(job)
    
    def execution(self, job):
        
        Global.thread.error = False
        Global.thread.error_message = None
        
        Global.progress.register(id(threading.currentThread()))
        job.result = job.function(*job.args)
        Global.progress.finalize(id(threading.currentThread()))

# Create thread pool
pool = Queue.Queue(0)

def run_thread(function, args):
    
    # Create a global class
    holder = Holder()
    holder.function = function
    holder.args = args
    holder.result = None
    
    # Send it to the queue
    pool.put(holder)
    
    return holder
