#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Nathan Samson
# Copyright (C) 2008 Siegfried-A. Gevatter
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

import gobject
import gtk

from leonov.gtk.buginfowidgetgeneral import BugInfoWidgetGeneral
from leonov.gtk.buginfowidgetcomments import BugInfoWidgetComments
from leonov.gtk.buginfowidgetbranches import BugInfoWidgetBranches
from leonov.gtk.buginfowidgetactivity import BugInfoWidgetActivity
from leonov.gtk.buginfowidgetmoreinformation import BugInfoWidgetMoreInformation

class BugInfoWidget(gtk.Notebook):

    __gsignals__ = {"show-reporters-task-list" : (gobject.SIGNAL_RUN_FIRST, 
                                                  gobject.TYPE_NONE,
                                                  (gobject.TYPE_STRING, ))}

    def __init__(self):
        gtk.Notebook.__init__(self)
        
        builder = gtk.Builder()
        builder.add_from_file("leonov/gtk/leonov-buginfo.ui")
        
        self._general = BugInfoWidgetGeneral(builder)
        self._general.connect("show-reporters-task-list",
                              self._onShowReportersTaskListButtonClicked)
        self._comments = BugInfoWidgetComments(builder)
        self._branches = BugInfoWidgetBranches()
        self._activity = BugInfoWidgetActivity()
        self._moreInfo = BugInfoWidgetMoreInformation(builder)
        
        self.append_page(self._general, gtk.Label("General"))
        self.append_page(self._comments, gtk.Label("Comments"))
        self.append_page(self._branches, gtk.Label("Branches"))
        self.append_page(self._moreInfo, gtk.Label("More information"))
        self.append_page(self._activity, gtk.Label("Activities"))
        self._general.show()
        self._comments.show()
        self._branches.show()
        self._activity.show()
        self._moreInfo.show()
        self.showBug(None)

    def showBug(self, bug):
        self._general.showBug(bug)
        self._comments.showBug(bug)
        self._branches.showBug(bug)
        self._activity.showBug(bug)
        self._moreInfo.showBug(bug)
    
    def _onShowReportersTaskListButtonClicked(self, object, reporter):
        self.emit("show-reporters-task-list", reporter)
