#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Nathan Samson
# Copyright (C) 2008 Siegfried-A. Gevatter
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

import gtk

from leonov.gtk.objects.treeview import SimplifiedTreeView

class BugInfoWidgetActivity(gtk.ScrolledWindow):

    def __init__(self):
        gtk.ScrolledWindow.__init__(self)
        self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        
        self._model = gtk.ListStore(str, str, str, str, str, str)
        
        treeview = SimplifiedTreeView(self._model)
        treeview.add_columns('Date', 'Who', 'What changed', 'Old value',
            'New value', 'Message')
        treeview.show()
        self.add_with_viewport(treeview)
    
    def showBug(self, bug = None):
        self._model.clear()
        self._bug = bug
        if not bug:
            return
        
        for activityEntry in bug.activity:
            self._addActivityEntry(activityEntry)
    
    def _addActivityEntry(self, entry):
        try:
            date = str(entry.date)
        except Exception, e:
            date = "-"
            print "Could not convert time, this is a bug that will be fixed soon"
        if entry.user:
            user = entry.user.realname
        else:
            user = ""
        what = entry.what
        old_value = entry.old_value
        new_value = entry.new_value
        message = entry.message
        self._model.append([date, user, what, old_value, new_value, message])
