#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Nathan Samson
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

import gtk

class BugInfoWidgetMoreInformation(gtk.ScrolledWindow):

    def __init__(self, builder):
        gtk.ScrolledWindow.__init__(self)
        self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self._builder = builder
        self._builder.get_object("bugInfoWidgetMoreInformation").unparent()
        self.add_with_viewport(self._builder \
                                   .get_object("bugInfoWidgetMoreInformation"))
        
        self._duplicatesModel = gtk.ListStore(str)
        col = gtk.TreeViewColumn('Task no', gtk.CellRendererText(), text=0)
        self._builder.get_object("duplicatesTreeView") \
                     .set_model(self._duplicatesModel)
        self._builder.get_object("duplicatesTreeView").append_column(col)
        
        self._subscribersModel = gtk.TreeStore(str, str)
        col = gtk.TreeViewColumn('Type ', gtk.CellRendererText(), text=0)
        col2 = gtk.TreeViewColumn('Subscribers name', gtk.CellRendererText(), text=1)
        self._builder.get_object("subscribersTreeView") \
                     .set_model(self._subscribersModel)
        self._builder.get_object("subscribersTreeView").append_column(col)
        self._builder.get_object("subscribersTreeView").append_column(col2)
    
    def showBug(self, bug):
        self._duplicatesModel.clear()
        self._subscribersModel.clear()
        if not bug:
            return
        for duplicate in bug.duplicates:
            self._duplicatesModel.append([duplicate])
        
        direct_list = bug.get_subscriptions_category("directly")
        iter = self._subscribersModel.append(None, ["Subscribed themselves", None])
        self._appendSubscribtions(direct_list, iter)
        via_duplicates = bug.get_subscriptions_category("duplicates")
        iter = self._subscribersModel.append(None, ["Via duplicates", None])
        self._appendSubscribtions(via_duplicates, iter)
        also_notified = bug.get_subscriptions_category("notified")
        iter = self._subscribersModel.append(None, ["Also notified", None])
        self._appendSubscribtions(also_notified, iter)

    def _appendSubscribtions(self, list, iter):
        for user in list:
            if user.realname:
                name = user.realname + " ("+str(user)+")"
            else:
                name = str(user)
            
            self._subscribersModel.append(iter, [None, name])
