#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Siegfried-A. Gevatter
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

import gtk

class SimplifiedTreeView(gtk.TreeView):
    
    _col_count = 0
   
    def add_column(self, name, column=None):
    	"""Warning: Do not call this function (in the same instance of this
    	class) sometimes with and sometimes without the "column" argument."""
    	if not column:
    		column = self._col_count
    		self._col_count += 1
        col = gtk.TreeViewColumn(name, gtk.CellRendererText(),
            text=column)
        col.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.append_column(col)
    
    def add_columns(self, *entries):
    	"""There are two possible ways to call this function: add_columns('C1',
    	'C2', 'C3'), which will automatically assign all columns sequential
    	"text" values, or add_columns(('C1', 1), ('C2', 2), ('C3', 3). Both
    	can't be combined."""
    	for entry in entries:
    		if hasattr(entry, '__iter__'):
    			self.add_column(*entry)
    		else:
    			self.add_column(entry)
    
    def connect_selection_change(self, call):
    	self.get_selection().connect('changed', call)
