#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

import sys
try:
    from PyKDE4.kdecore import ki18n, KAboutData, KCmdLineArgs
    from PyKDE4.kdeui import KApplication
except ImportError:
    print "You need the python-kde4 bindings"
    exit(0)
try:
    from PyQt4.QtCore import Qt, SIGNAL, QEvent, QCoreApplication
    from PyQt4.QtGui import QLabel
except ImportError:
    print "You need the python-qt4 bindings"
    exit(0)

from views.mainwindow import MainWindow

class frontend:
    def __init__(self):
        self.start() 
    
    def start(self):
        appName     = "leonov"
        catalog     = ""
        programName = ki18n ("Leonov")
        version     = "0.1"
        description = ki18n ("Leonov Desktop Client")
        license     = KAboutData.License_GPL_V2
        copyright   = ki18n ("The Leonov Team")
        text        = ki18n ('"Leonov" is a desktop client for Launchpad. Leonov is not bound to KDE/Qt or GNOME/Gtk. Whatever you can do with Launchpad, there will be a representation in Leonov.')
        homePage    = "leonov.tv"
        bugEmail    = "sh@sourcecode.de"

        aboutData = KAboutData(appName, catalog, programName, version, description, 
                            license, copyright, text, homePage, bugEmail)
        aboutData.addAuthor(ki18n("Stephan Hermann"),ki18n("KDE Frontend, Backend"),"sh@sourcecode.de","http://www.sourcecode.de/")
        aboutData.addAuthor(ki18n("Nathan Samson"),ki18n("GTK/Gnome Frontend"),"nathansamson@gmail.com")
        aboutData.addAuthor(ki18n("Siegfried-A. Gevatter"),ki18n("GTK/Gnome Frontend, Backend"),"rainct@ubuntu.com")
        aboutData.addAuthor(ki18n("Markus Korn"),ki18n("Backend, Python-Launchpad-bugs improvement"),"thekorn@gmx.de")
        aboutData.addCredit(ki18n("Marc Cheng"),ki18n("Web Layout/Drupal"),"bdgraue@web.de")
        aboutData.addCredit(ki18n("Andrew H."),ki18n("Logo, Icon Design"),"rainct@ubuntu.com")
        aboutData.addCredit(ki18n("Celeste Lyn Paul"),ki18n("KDE Usability testing, UI Reports"),"celeste@kde.org","http://celestelynpaul.com/")
        aboutData.addCredit(ki18n("Python Launchpad Bug - Team"),ki18n("Python Launchpad Bug Library"))
        aboutData.addCredit(ki18n("Launchpad Developer Team"),ki18n("Working on Launchpad"),"launchpad-bugs@lists.ubuntu.com ","http://launchpad.net")
        aboutData.addCredit(ki18n("Mark Shuttleworth"),ki18n("Canonical Boss, Ubuntu Sponsor, Launchpad Developer and Architect, First African in Space"),"","http://www.markshuttleworth.com/")
        KCmdLineArgs.init(aboutData)
        g_app=KApplication()
        mainWindow=MainWindow()
        mainWindow.show()
        g_app.exec_()
