#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

from PyQt4.QtCore import QObject, Qt, SIGNAL, SLOT, QString, QStringList, QThread
import logging

class GetProjectListThread(QThread):
    def __init__(self,lpbug):
        QThread.__init__(self)
        self.lpbug=lpbug
        self.projectList=[]
        self.connect(self,SIGNAL("finished()"),self.task_finished)
    def run(self):
        logging.getLogger("leonov.kde.models.thread.workers").debug("GetProjectListThread: running")
        if self.lpbug:
            self.projectList=self.lpbug.getProjectList()
        
    def task_finished(self):
        logging.getLogger("leonov.kde.models.thread.workers").debug("GetProjectListThread: finished")
        if self.projectList:
            if not self.lpbug.getErrorState():
                self.emit(SIGNAL("receivedProjectList"),self.projectList)
            
class GetBugListThread( QThread ):
    def __init__( self, lpType, lpbug, personal=True, username="" ):
        QThread.__init__( self )
        self.lpType=lpType
        self.lpbug=lpbug
        self.personal=personal
        self.username=username
        self.bugList=[]
        self.connect(self,SIGNAL("finished()"),self.task_finished)
    def run( self ):
        logging.getLogger( "leonov.kde.modes.MyBugListFill" ).debug( "QThread: lpType: %d Username: %s ", self.lpType,self.username )
        if self.personal:
            self.bugList=self.lpbug.getMyBugList( self.lpType )
        else:
            self.bugList=self.lpbug.getBugListForUser(self.username,self.lpType)
        
    def task_finished(self):
        if not self.lpbug.getErrorState():      
            self.emit( SIGNAL( "receiveBugList" ), self.bugList, self.lpType )
            
class GetBugThread( QThread ):
     def __init__( self, bugno, lpbug ):
         QThread.__init__( self )
         self.bugno=bugno
         self.lpbug=lpbug
         self.connect(self,SIGNAL("finished()"),self.task_finished)
     def run( self ):
         logging.getLogger( "leonov.kde.models.GetBugThread" ).debug( "GetBugThread Started: fetching bug %d", self.bugno )
         bugReport=self.lpbug.getBugReport( self.bugno )
         
     def task_finished(self):
         self.emit( SIGNAL( "BugReportFetched" ), bugReport )
         
class LoginThread(QThread):
    def __init__(self,lpbug,username,password):
        QThread.__init__(self)
        self.lpbug=lpbug
        self.username=username
        self.password=password
        
    def run(self):
        logging.getLogger("leonov.kde.models.LoginThread").debug("LoginThread Started")
        self.lpbug.authenticateLPUser(self.username,self.password)
        
        