#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
# Copyright (C) 2008 Siegfried-A. Gevatter
# Copyright (C) 2008 Markus Korn
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

from PyKDE4.kdeui import KApplication, KMenu
from PyKDE4.kdecore import i18n
from PyQt4.QtGui import QWidget, QVBoxLayout, QTreeWidget, QTreeWidgetItem, QPushButton, QMenu
from PyQt4.QtCore import SIGNAL, SLOT, QStringList, Qt, QObject, QVariant



class ContextMenu(QObject):
    
    def __init__(self,parent=None):
        QObject.__init__(self,parent)
        self.menuEntries={}
    def createMenu(self,title=""):
        self.popup_menu=KMenu(title,self.parent())
    def addAction(self,icon=None,menuText="",enabled=True,identify_text=""):
            self.menuEntries[identify_text]=self.popup_menu.addAction(menuText)
            if icon:
                self.menuEntries[identify_text].setIcon(icon)
            if not enabled:
                self.menuEntries[identify_text].setEnabled(False)
            else:
                self.menuEntries[identify_text].setEnabled(True)
            self.menuEntries[identify_text].setData(QVariant(identify_text))
    def addSeparator(self):
        self.popup_menu.addSeparator()
    def setEnabled(self,identify_text,enabled):
        if self.menuEntries.has_key(identify_text):
            self.menuEntries[identify_text].setEnabled(enabled)
    def getMenu(self):
        return self.popup_menu
    def getMenuEntry(self,identify_text):
        return self.menuEntries[identify_text]

    def createPopup(self,menu_title="",entries=None):
        self.createMenu(menu_title)
        if entries:
            for entry in entries:
                if entry["title"]=="---":
                    self.addSeparator()
                else:
                    self.addAction(entry["icon"],entry["title"],entry["enabled"],entry["ident"])
    def prepareMenu(self,menu_title=""):
        pass
    
class AttachmentContextMenu(ContextMenu):
       
    def __init__(self,parent=None,menu_title="",filename=None, selected_items=1):
        ContextMenu.__init__(self,parent)
        if selected_items>1:
            multiple=True
            single=False
        else:
            multiple=False
            single=True
            
        entries=[{'icon':None,'title':i18n("Save %1",filename),'enabled':single, 'ident':"SaveAttachment"},
                 {'icon':None,'title':i18n("Save %1 to...",filename),'enabled':single,'ident':"SaveAttachmentTo"},
                 {'icon':None,'title':"---",'enabled':False,'ident':"Separator"},
                 {'icon':None,'title':i18n("Save all"),'enabled':multiple,'ident':"SaveAll"},
                 {'icon':None,'title':i18n("Save all to..."),'enabled':multiple,'ident':"SaveAllTo"}]        
        self.createPopup(menu_title,entries)
