# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################
from PyKDE4.kdeui import KApplication, KDialog, KLineEdit
from PyKDE4.kdecore import i18n
from PyQt4.QtGui import QWidget
from PyQt4.QtCore import SIGNAL, SLOT, QObject

from UI import Ui_dlgGetLaunchpadUsername
import logging

class dlgGetLaunchpadUsernameWidget(QWidget):
    
    def __init__(self,parent=None):
        QWidget.__init__(self,parent)
        self.ui=Ui_dlgGetLaunchpadUsername()
        self.setupView()
        
    def setupView(self):
        self.ui.setupUi(self)
        self.ui.editLaunchpadUser.setFocus()
    
    def setLaunchpadUsername(self,username):
        self.ui.editLaunchpadUser.setText(username)
    def getLaunchpadUsername(self):
        return self.ui.editLaunchpadUser.text()
    
class DlgGetLaunchpadUsername(QObject):
    
    def __init__(self,parent=None):
        QObject.__init__(self,parent)
        self.dlg=KDialog(parent)
        self.launchpadUsername=dlgGetLaunchpadUsernameWidget(self.dlg)
        self.dlg.setMainWidget(self.launchpadUsername)
    
    def getLPUsername(self):
        return self.launchpadUsername.getLaunchpadUsername()
    def exec_(self):
        return self.dlg.exec_()
    