#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

from PyKDE4.kdeui import KApplication, KDialog, KLineEdit
from PyKDE4.kio import KFileDialog
from PyKDE4.kdecore import i18n, KUrl
from PyQt4.QtGui import QWidget
from PyQt4.QtCore import QObject, SIGNAL, SLOT

from UI import Ui_viewLoginDlg
from leonov.backend import config

class _ViewPreferences(QWidget):
    
    def __init__(self,parent=0):
        QWidget.__init__(self,parent)
        self.ui=Ui_viewLoginDlg()
        self.tempUser=""
        self.tempCookie=""
        self.tempPassword=""
        self.ui.setupUi(self)
        self.setupSlots()

    def setupSlots(self):
        #self.connect(self.ui.editLaunchpadEmail,SIGNAL("textChanged(QString)"),self.LPUsernameValueChanged)
        #self.connect(self.ui.editPassword,SIGNAL("textChanged(QString)"),self.LPPasswordValueChanged)
        pass
    

    def getLaunchpadUsername(self):
        return self.ui.editLaunchpadEmail.text()
    def getLaunchpadPassword(self):
        return self.ui.editPassword.text()
    def setLaunchpadUsername(self,username):
        self.ui.editLaunchpadEmail.setText(username)
        self.tempUser=username
        self.ui.editLaunchpadEmail.setFocus()
    def setLaunchpassPassword(self,password):
        self.ui.editPassword.setText(password)
        self.tempPassword=password

class ViewLoginDlg(QObject):
    
    def __init__(self,parent=0):
        QObject.__init__(self,parent)
        self.dlg=KDialog(parent)
        self.dlg.setCaption(i18n("Leonov - Login"))
        self.dlg.setButtons(KDialog.ButtonCode(KDialog.Ok | KDialog.Cancel))
        self.connect(self.dlg,SIGNAL("okClicked()"),self.saveSettings)
        self.viewPrefs=_ViewPreferences(self.dlg)
        self.dlg.setMainWidget(self.viewPrefs)
        self.dlg.enableButtonApply(False)
        self.viewPrefs.setLaunchpadUsername(config.get_username())
    def exec_(self):
        return self.dlg.exec_()
    def saveSettings(self):
        config.set_username(str(self.viewPrefs.getLaunchpadUsername()))
        config.save()        
    def getPassword(self):
        # Be careful with interchanging python strings and Qt QStrings
        return str(self.viewPrefs.getLaunchpadPassword())
