#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################
from PyKDE4.kdeui import KApplication,  KTabWidget
from PyKDE4.kdecore import i18n
from PyQt4.QtGui import QLabel, QTabWidget, QWidget,  QGridLayout,  QHBoxLayout,  QRadioButton, QColumnView,  QMessageBox,  QTreeWidget,  QTreeWidgetItem, QDockWidget
from PyQt4.QtCore import QSize, QRect,  SIGNAL,  SLOT,  QStringList, Qt
from UI import Ui_mainTabView
import logging

class mainTabViewWidget(QWidget):
    
    def __init__(self,parent=None):
        QWidget.__init__(self,parent)
        self.ui=Ui_mainTabView()
        self.setupView()
        self.setupSlots()
        
    def setupView(self):
        self.ui.setupUi(self)
        self.ui.tabMainPanel.setHoverCloseButton(True)
    def setupSlots(self):
        self.connect(self.ui.tabMainPanel,SIGNAL("closeRequest(QWidget *)"),self.slotTabClosing)
    
    def slotTabClosing(self,widget):
        self.emit(SIGNAL("tabClosing"),widget.windowTitle())
        self.ui.tabMainPanel.removePage(widget)
        
        
    def addTask(self,taskWidget=None,title=""):
        self.ui.tabMainPanel.addTab(taskWidget,taskWidget.windowTitle())
        self.ui.tabMainPanel.setCurrentIndex(self.ui.tabMainPanel.count()-1)
        
    def setActiveTab(self,widget):
        self.ui.tabMainPanel.setCurrentWidget(widget)
    def setTabPosition(self, position):
        self.ui.tabMainPanel.setTabPosition(position)  
        